/* params.h */

/* EMACS_MODES: c !fill */

/* This file contains the standard data types, etc. for the icmp process. */


#define	reg		register

typedef	unsigned short	unshort;	/* an unsigned short */
typedef	char	*caddr_t;		/* core address */


#define	NULL		0
#define	MAXUNS		65536		/* max. unsigned short integer */
#define	SIGCTLA		16		/* special interrupt signal */
#define	SIGAIO		17		/* net interrupt signal */
#define	SIGLOG		20		/* base of logging control signals */


/* Logging level bit definitions */

#define	LOG_ERR		1		/* log all errors */
#define	LOG_LOC		2		/* log local transactions */
#define	LOG_FOR		4		/* log foreign transactions */
#define	LOG_XMT		8		/* log transmitted packets */
#define	LOG_RCV		16		/* log received packets */

#define	MAX_LOG		4		/* bit. no. of max. used log bit */


/* Miscellaneous definitions */

#define	TRUE		1
#define	FALSE		0
#define	NAMESIZE	64		/* max. size of a name */
#define	TIMEOUT		5		/* echo/timestamp packet timeout */
#define	RETRIES		3		/* no. of echo/timestamp tries */
#define	INPKT		1		/* input packet flag */
#define	OUTPKT		0		/* output packet flag */
#define	FILL		TRUE		/* fill internet header */
#define	NOFILL		FALSE		/* don't fill internet header */
#define	NOFILE		20		/* max open files per process */

/* Generally useful macros */

#define	min(x,y)	((x) < (y) ? (x) : (y))
